// G`֐
unit UnitGraph;

interface

uses
   Windows,Graphics, SysUtils, UnitFunc, UnitClip, UnitGVar ;

procedure G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
procedure GRB_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Double);
procedure GRB_CIRCLE(C:TCanvas;rx1,ry1,rr1:Double);
procedure GRB_ARC(C:TCanvas;rx1,ry1,rr1,ra1,ra2:Double);
procedure GRB_BOX(C:TCanvas;rx1,ry1,rx2,ry2:Integer);

procedure GL_LINE(C:TCanvas;x1,y1,x2,y2:double) ;
procedure GL_LINE2(C:TCanvas;x1,y1,x2,y2:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;
procedure GL_CIRCLE(C:TCanvas;x1,y1,r1:double) ;
procedure GL_CIRCLE2(C:TCanvas;x1,y1,r1:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;
procedure GL_ARC(C:TCanvas;x1,y1,r1,a1,a2:double) ;
procedure GL_ARC2(C:TCanvas;x1,y1,r1,a1,a2:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;
procedure GL_POINT(C:TCanvas;x1,y1:double) ;
procedure GL_CHAR(C:TCanvas;x1,y1,h1,w1,a1:double;z1:integer;f1,s1:string) ;
procedure GL_TEXT(C:TCanvas;x1,y1,h1,w1,d1,a1:double;z1:integer;f1,s1:string) ;

procedure GL_PAPERFRAME(C:TCanvas) ;
procedure GL_ALLDAT(C:TCanvas) ;

implementation

// ʂNA
procedure G_CLS(C:TCanvas;x1,y1,x2,y2:integer) ;
begin
   with C do begin
      with Pen do begin
         Mode  := pmCopy ;
         Color := clWhite;
         Style := psSolid;
         Width := 1;
      end;
      with Brush do begin
         Color := clWhite;
         Style := bsSolid;
      end;
      Rectangle(x1,y1,x2,y2);
   end;
end;

// o[oh`
procedure GRB_LINE(C:TCanvas;rx1,ry1,rx2,ry2:Double);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
   end;
   GL_LINE(C,rx1,ry1,rx2,ry2);
end;

// o[oh~`
procedure GRB_CIRCLE(C:TCanvas;rx1,ry1,rr1:Double);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
   end;
   GL_CIRCLE(C,rx1,ry1,rr1) ;
end;

// o[oh~ʕ`
procedure GRB_ARC(C:TCanvas;rx1,ry1,rr1,ra1,ra2:Double);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;
      Pen.Width := 0 ;
      Pen.Style := psSolid ;
   end;
   GL_ARC(C,rx1,ry1,rr1,ra1,ra2);
end;

// hbOpo[oh``
procedure GRB_BOX(C:TCanvas;rx1,ry1,rx2,ry2:Integer);
begin
   with C do begin
      Pen.Mode := pmXor ;
      Pen.Color := clAqua ;   // ԐF
      if (rx1 > rx2)and(ry1 < ry2)
       or(rx1 < rx2)and(ry1 > ry2) then
         Pen.Color := clyellow ;    // F
      Pen.Width := 2 ;
      Pen.Style := psSolid ;
      Brush.Style := bsClear ;
      Rectangle(rx1,ry1,rx2,ry2);
   end;
end;

// ========== ========== ==========

// [mm]}
procedure GL_LINE(C:TCanvas;x1,y1,x2,y2:double) ;
var
   i : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   ax1,ay1,ax2,ay2 : integer ;
begin
   wx1 := x1 ;    wy1 := y1 ;
   wx2 := x2 ;    wy2 := y2 ;
   i := ClipLine(wx1,wy1,wx2,wy2,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i < 2) then begin
      ax1 := Round( (wx1 - WD_x1 ) * MM_dot );
      ay1 := Round(-(wy1 - WD_y2 ) * MM_dot );
      ax2 := Round( (wx2 - WD_x1 ) * MM_dot );
      ay2 := Round(-(wy2 - WD_y2 ) * MM_dot );
      C.MoveTo(ax1,ay1);
      C.LineTo(ax2,ay2);
   end;
end;

// [mm]}ilj
//    ptnn : p^[
//    ptns : p^[iړxZρj
//    ptn1 : in : }Jnp^[
//           out: }I̐p^[
//    ptn2 : in : p^[̊Jn
//           out: }I̐p^[̏I
procedure GL_LINE2(C:TCanvas;x1,y1,x2,y2:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;
var
   a : double ;   // Xpx[rad]
   l : double ;   // 
   lx1,ly1,lx2,ly2,ll,p : double ;
   ii : integer ;
   f : Boolean ;
begin
   if (ptnn <= 1) then
      GL_LINE(C,x1,y1,x2,y2)
   else begin
      a  := GetAngle(x1,y1,x2,y2);
      l  := GetLength(x1,y1,x2,y2);
      lx1:= x1 ;
      ly1:= y1 ;
      ii := ptn1 ;
      ll := 0 ;
      p  := Abs(ptns[ii]) - ptn2 ;
      if (p >= l) then begin
         if (ptns[ii] > 0.0) then GL_LINE(C,x1,y1,x2,y2);
         ptn2 := ptn2 + l ;
         exit ; 
      end;

      f  := True ;
      while(f) do begin
         if (ll+p >= l) then begin
            p := l - ll;
            f := False ;
         end;
         lx2 := lx1 + p*Cos(a);
         ly2 := ly1 + p*Sin(a);
         if (ptns[ii] = 0.0) then GL_CIRCLE(C,lx1,ly1,1.0/MM_dot)
         else if (ptns[ii] > 0.0) then GL_LINE(C,lx1,ly1,lx2,ly2);
         lx1 := lx2 ;
         ly1 := ly2 ;
         ll  := ll + p ;
         if (f) then begin
            Inc(ii);
            if (ii >= ptnn) then ii := 0;
            p := Abs(ptns[ii]);
         end;
      end;
      ptn1 := ii;
      ptn2 := p;
   end;
end;

// ~[mm]}
procedure GL_CIRCLE(C:TCanvas;x1,y1,r1:double) ;
var
   i,j : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   ax1,ay1,ax2,ay2 : integer ;
   a1,a2 : double ;
   n : integer ;
   an1,an2 : array[0..4] of double ;
begin
   wx1 := x1-r1 ;    wy1 := y1-r1 ;
   wx2 := x1+r1 ;    wy2 := y1+r1 ;
   i := ClipPoint(wx1,wy1,WD_x1,WD_y1,WD_x2,WD_y2);
   j := ClipPoint(wx2,wy2,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 0)and(j = 0) then begin
      ax1 := Round( (wx1 - WD_x1 ) * MM_dot );
      ay1 := Round(-(wy1 - WD_y2 ) * MM_dot );
      ax2 := Round( (wx2 - WD_x1 ) * MM_dot );
      ay2 := Round(-(wy2 - WD_y2 ) * MM_dot );
      C.Ellipse(ax1,ay1,ax2,ay2);
   end
   else begin
      i := ClipArc(x1,y1,r1,0.0,0.0,n,an1,an2,WD_x1,WD_y1,WD_x2,WD_y2);
      if (i = 2) then exit ;
      for i:=0 to n-1 do begin
         a1 := an1[i] ;
         a2 := an2[i] - an1[i] ;
         a2 := a2 / 18.0 ;
         wx1 := x1 + r1 * Cos(a1);
         wy1 := y1 + r1 * Sin(a1);
         for j:=1 to 18 do begin
           	a1 := a1 + a2;
     	      wx2 := x1 + r1 * Cos(a1);
        	   wy2 := y1 + r1 * Sin(a1);
            GL_LINE(C,wx1,wy1,wx2,wy2);
            wx1 := wx2 ;
            wy1 := wy2 ;
      	end;
      end;
   end;
end;

// ~[mm]}ilj
procedure GL_CIRCLE2(C:TCanvas;x1,y1,r1:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;
var
   n : integer ;
   an1,an2 : array[0..4] of double ;
   i,j : integer ;
   a1,a2 : double ;
   wx1,wy1,wx2,wy2 : Double ;
begin
   i := ClipArc(x1,y1,r1,0.0,0.0,n,an1,an2,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 2) then exit ;
   for i:=0 to n-1 do begin
      a1 := an1[i] ;
      a2 := an2[i] - an1[i] ;
      a2 := a2 / 18.0 ;
      wx1 := x1 + r1 * Cos(a1);
      wy1 := y1 + r1 * Sin(a1);
      for j:=1 to 18 do begin
        	a1 := a1 + a2;
     	   wx2 := x1 + r1 * Cos(a1);
        	wy2 := y1 + r1 * Sin(a1);
         GL_LINE2(C,wx1,wy1,wx2,wy2,ptnn,ptns,ptn1,ptn2);
         wx1 := wx2 ;
         wy1 := wy2 ;
   	end;
   end;
end;

// ~[mm]}
procedure GL_ARC(C:TCanvas;x1,y1,r1,a1,a2:double) ;
var
   i,j : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   ax1,ay1,ax2,ay2 : integer ;
   ax3,ay3,ax4,ay4 : integer ;
   a3,a4 : double ;
   n : integer ;
   an1,an2 : array[0..4] of double ;
begin
   wx1 := x1-r1 ;    wy1 := y1-r1 ;
   wx2 := x1+r1 ;    wy2 := y1+r1 ;
   i := ClipPoint(wx1,wy1,WD_x1,WD_y1,WD_x2,WD_y2);
   j := ClipPoint(wx2,wy2,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 0)and(j = 0) then begin
      ax1 := Round( (wx1 - WD_x1 ) * MM_dot );
      ay1 := Round(-(wy1 - WD_y2 ) * MM_dot );
      ax2 := Round( (wx2 - WD_x1 ) * MM_dot );
      ay2 := Round(-(wy2 - WD_y2 ) * MM_dot );
      ax3 := Round( ((x1+r1*Cos(a1/180.0*PI)) - WD_x1 ) * MM_dot );
      ay3 := Round(-((y1+r1*Sin(a1/180.0*PI)) - WD_y2 ) * MM_dot );
      ax4 := Round( ((x1+r1*Cos(a2/180.0*PI)) - WD_x1 ) * MM_dot );
      ay4 := Round(-((y1+r1*Sin(a2/180.0*PI)) - WD_y2 ) * MM_dot );
      C.Arc(ax1,ay1,ax2,ay2,ax3,ay3,ax4,ay4);
   end
   else begin
      i := ClipArc(x1,y1,r1,a1/180.0*Pi,a2/180.0*Pi,n,an1,an2,WD_x1,WD_y1,WD_x2,WD_y2);
      if (i = 2) then exit ;
      for i:=0 to n-1 do begin
         a3 := an1[i] ;
         a4 := an2[i] - an1[i] ;
         a4 := a4 / 18.0 ;
         wx1 := x1 + r1 * Cos(a3);
         wy1 := y1 + r1 * Sin(a3);
         for j:=1 to 18 do begin
           	a3 := a3 + a4;
     	      wx2 := x1 + r1 * Cos(a3);
        	   wy2 := y1 + r1 * Sin(a3);
            GL_LINE(C,wx1,wy1,wx2,wy2);
            wx1 := wx2 ;
            wy1 := wy2 ;
      	end;
      end;
   end;
end;

// ~[mm]}ilj
procedure GL_ARC2(C:TCanvas;x1,y1,r1,a1,a2:double;ptnn:integer;ptns:array of Double;var ptn1:integer;var ptn2:Double) ;
var
   i,j : integer ;
   wx1,wy1,wx2,wy2 : Double ;
   a3,a4 : double ;
   n : integer ;
   an1,an2 : array[0..4] of double ;
begin
   i := ClipArc(x1,y1,r1,a1/180.0*Pi,a2/180.0*Pi,n,an1,an2,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 2) then exit ;
   for i:=0 to n-1 do begin
      a3 := an1[i] ;
      a4 := an2[i] - an1[i] ;
      a4 := a4 / 18.0 ;
      wx1 := x1 + r1 * Cos(a3);
      wy1 := y1 + r1 * Sin(a3);
      for j:=1 to 18 do begin
        	a3 := a3 + a4;
  	      wx2 := x1 + r1 * Cos(a3);
     	   wy2 := y1 + r1 * Sin(a3);
         GL_LINE2(C,wx1,wy1,wx2,wy2,ptnn,ptns,ptn1,ptn2);
         wx1 := wx2 ;
         wy1 := wy2 ;
   	end;
   end;
end;

// _[mm]}iThbǵ~}j
procedure GL_POINT(C:TCanvas;x1,y1:double) ;
var
   i : integer ;
   wx1,wy1,wx2,wy2 : Double ;
begin
   i := ClipPoint(x1,y1,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 0) then begin
      wx1 := x1 - 2.0/MM_dot ;
      wy1 := y1 - 2.0/MM_dot ;
      wx2 := x1 + 3.0/MM_dot ;
      wy2 := y1 + 3.0/MM_dot ;
      GL_LINE(C,wx1,wy1,wx2,wy2);
      wx1 := x1 - 2.0/MM_dot ;
      wy1 := y1 + 2.0/MM_dot ;
      wx2 := x1 + 3.0/MM_dot ;
      wy2 := y1 - 3.0/MM_dot ;
      GL_LINE(C,wx1,wy1,wx2,wy2);
   end;
end;

// P}[mm]
procedure GL_CHAR(C:TCanvas;x1,y1,h1,w1,a1:double;z1:integer;f1,s1:string) ;
var
   x,y,w2 : double ;
   i : integer ;
   LogFont : TLogFont ;
   ih,iw,ia , ib,ii,ix,iy : Integer ;
begin
   if (s1 = '')or(s1 = ' ')or(s1 = '@') then exit;
   // NbsO`FbN
   i := ClipPoint(x1,y1,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 2) then exit ;
   w2:= w1 ;   if (Length(s1)=1) then w2:=w1/2.0;
   x := x1 + w2*Cos(a1/180.0*Pi);
   y := y1 + w2*Sin(a1/180.0*Pi);
   i := ClipPoint(x,y,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 2) then exit ;
   x := x1 + h1*Cos((a1-90.0)/180.0*Pi);
   y := y1 + h1*Sin((a1-90.0)/180.0*Pi);
   i := ClipPoint(x,y,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 2) then exit ;
   x := x1+RevX(w2,-h1,0.0,0.0,a1/180.0*Pi);
   y := y1+RevY(w2,-h1,0.0,0.0,a1/180.0*Pi);
   i := ClipPoint(x,y,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 2) then exit ;

   ih := Round(h1 * MM_dot) ;
   iw := Round(w1/ 2.0 * MM_dot) ;  // p
   ia := Round(a1*10.0) ;
   if (ih < 4) then begin
      GL_LINE(C,x1,y1,x1+w1,y1);
      exit ;
   end;
   if (ih > 500) then ih := 500;

   ib := FW_NORMAL ;
   if ((z1 mod 10)=1) then ib := FW_BOLD ;
   ii := 0 ;
   if ((z1 div 10)=1) then ii := 1 ;

   ix := Round( (x1 - WD_x1 ) * MM_dot );
   iy := Round(-(y1 - WD_y2 ) * MM_dot );

   with LogFont do begin
      lfHeight := ih ;        // 
      lfWidth  := iw ;        // 
      lfEscapement := ia ;    // ]px[] 10{l
      lfOrientation := ia ;   // lfEscapementƓl
      lfWeight := ib ;        // w ʏ FW_NORMAL
      lfItalic := ii ;        // Α̎w L=1 =0
      lfUnderline := 0 ;      // w L=1 =0
      lfStrikeOut := 0 ;      // w L=1 =0
      lfCharSet := DEFAULT_CHARSET ;
      lfOutPrecision := OUT_DEFAULT_PRECIS ;
      lfClipPrecision := CLIP_DEFAULT_PRECIS ;
      lfQuality := DEFAULT_QUALITY ;
      lfPitchAndFamily := DEFAULT_PITCH ;
      StrPCopy(lfFaceName,f1);   // tHg
   end;
   with C do begin
      Font.Handle := CreateFontIndirect(LogFont);
      Brush.Color := $f0f0f0 ;
      Brush.Style := bsSolid ;
      TextOut(ix,iy,s1);
   end;
end;

// }[mm]
procedure GL_TEXT(C:TCanvas;x1,y1,h1,w1,d1,a1:double;z1:integer;f1,s1:string) ;
var
   l,a2 : Double ;   // S
   dx,dy,x,y,ls : Double ;
   ss : String ;
   i ,zk : integer ;
begin
   l := Length(s1)*w1/2.0 + (KLength(s1)-1)*d1 ;
   a2:= a1*Pi/180.0 ;
   zk:= z1 div 100 ;
   // _̒
   dx:= 0.0 ;
   dy:= 0.0 ;
   Case (z1 mod 100)of
   { 0 :  0,0 }
   1: begin // 
         dx := 0.0 ;
         dy := h1/2.0 ;
      end;
   2: begin // 
         dx := 0.0 ;
         dy := h1 ;
      end;
   3: begin // 
         dx := -l/2.0 ;
         dy := 0.0 ;
      end;
   4: begin // 
         dx := -l/2.0 ;
         dy := h1/2.0 ;
      end;
   5: begin // 
         dx := -l/2.0 ;
         dy := h1 ;
      end;
   6: begin // E
         dx := -l ;
         dy := 0.0 ;
      end;
   7: begin // E
         dx := -l ;
         dy := h1/2.0 ;
      end;
   8: begin // E
         dx := -l ;
         dy := h1 ;
      end;
   end;
   x := x1 + dx*Cos(a2)-dy*Sin(a2) ;
   y := y1 + dx*Sin(a2)+dy*Cos(a2) ;

   // }
   for i:=1 to KLength(s1) do begin
      ss := Get1Char(s1,i);
      GL_CHAR(C,x,y,h1,w1,a1,zk,f1,ss);
      ls:= Length(ss)*w1/2.0 + d1 ;
      x := x + ls*Cos(a2);
      y := y + ls*Sin(a2);
   end;
end;

// ========== ========== ==========

// pg}
procedure GL_PAPERFRAME(C:TCanvas) ;
var
   sc : double ;
   x1,y1,x2,y2 : Double ;
   f : Boolean ;
   ff: Boolean ;
   i : integer ;
   ax1,ay1 : Integer ;
begin
   C.Pen.Mode  := pmCopy ;

   // Obh}
   if (GR_OnOff) then begin
      sc := 1.0 ;
      if (GR_Sunpo)and(WR_sc > 0.0) then sc := WR_sc ;
      // io[Wj
      if (GR_Type) then begin
         if (GR_Dist * sc * MM_dot > 10.0) then begin
            C.Pen.Color := $eeeeee ;
            // c
            f := True ;
            x1 := Int(WR_x1 / GR_Dist / sc) * GR_Dist * sc + WR_Ox ;
            while(f) do begin
               y1 := WR_y1 + WR_Oy ;
               x2 := x1 ;
               y2 := WR_y2 + WR_Oy ;
               GL_LINE(C,x1,y1,x2,y2);
               x1 := x1 + GR_Dist * sc ;
               if (x1 > (WR_x2+WR_Ox)) then f:=False;
            end;
            // 
            f := True ;
            y1 := Int(WR_y1 / GR_Dist / sc) * GR_Dist * sc + WR_Oy ;
            while(f) do begin
               x1 := WR_x1 + WR_Ox ;
               x2 := WR_x2 + WR_Ox ;
               y2 := y1 ;
               GL_LINE(C,x1,y1,x2,y2);
               y1 := y1 + GR_Dist * sc ;
               if (y1 > (WR_y2+WR_Oy)) then f:=False;
            end;
         end;
         if (GR_Dist * sc * 5.0 * MM_dot > 10.0) then begin
            C.Pen.Color := $cccccc ;
            // c(~5)
            f := True ;
            x1 := Int(WR_x1 / GR_Dist / sc / 5.0) * GR_Dist * sc * 5.0 + WR_Ox ;
            while(f) do begin
               y1 := WR_y1 + WR_Oy;
               x2 := x1 ;
               y2 := WR_y2 + WR_Oy;
               GL_LINE(C,x1,y1,x2,y2);
               x1 := x1 + GR_Dist * sc * 5.0 ;
               if (x1 > (WR_x2+WR_Ox)) then f:=False;
            end;
            // (~5)
            f := True ;
            y1 := Int(WR_y1 / GR_Dist / sc / 5.0) * GR_Dist * sc * 5.0 + WR_Oy ;
            while(f) do begin
               x1 := WR_x1 + WR_Ox;
               x2 := WR_x2 + WR_Ox;
               y2 := y1 ;
               GL_LINE(C,x1,y1,x2,y2);
               y1 := y1 + GR_Dist * sc * 5.0 ;
               if (y1 > (WR_y2+WR_Oy)) then f:=False;
            end;
         end;
      end
      else begin
         // i_E~o[Wj
         if (GR_Dist * sc * MM_dot > 10.0) then begin
            f := True ;
            x1 := Int(WR_x1 / GR_Dist / sc) * GR_Dist * sc + WR_Ox;
            while(f) do begin
               ff := True ;
               y1 := Int(WR_y1 / GR_Dist / sc) * GR_Dist * sc + WR_Oy;
               while(ff) do begin
                  ax1 := Round( (x1 - WD_x1 ) * MM_dot );
                  ay1 := Round(-(y1 - WD_y2 ) * MM_dot );
                  C.Pixels[ax1,ay1] := clBlue ;
                  y1 := y1 + GR_Dist * sc ;
                  if (y1 > (WR_y2+WR_Oy)) then ff:=False;
               end;
               x1 := x1 + GR_Dist * sc ;
               if (x1 > (WR_x2+WR_Ox)) then f:=False;
            end;
         end;
         if (GR_Dist * sc * 5.0 * MM_dot > 10.0) then begin
            C.Pen.Color := $ffaaaa ;
            C.Brush.Color := $ffaaaa ;
            C.Brush.Style := bsSolid ;
            // c(~5)
            f := True ;
            x1 := Int(WR_x1 / GR_Dist / sc / 5.0) * GR_Dist * sc * 5.0 + WR_Ox;
            while(f) do begin
               ff := True ;
               y1 := Int(WR_y1 / GR_Dist / sc / 5.0) * GR_Dist * sc * 5.0 + WR_Oy;
               while(ff) do begin
                  ax1 := Round( (x1 - WD_x1 ) * MM_dot );
                  ay1 := Round(-(y1 - WD_y2 ) * MM_dot );
                  C.Ellipse(ax1-1,ay1-1,ax1+2,ay1+2);
                  y1 := y1 + GR_Dist * sc * 5.0 ;
                  if (y1 > (WR_y2+WR_Oy)) then ff:=False;
               end;
               x1 := x1 + GR_Dist * sc * 5.0 ;
               if (x1 > (WR_x2+WR_Ox)) then f:=False;
            end;
            C.Brush.Style := bsClear ;
         end;
      end;
   end;

   // pg}
   C.Pen.Color := clBlue ;
   C.Pen.Width := 0 ;
   C.Pen.Style := psSolid;

   x1 := -PA_x/2 ;  y1 := -PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 := -PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 := -PA_x/2 ;  y1 :=  PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 := -PA_x/2 ;  y1 := -PA_y/2 ;
   x2 := -PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);
   x1 :=  PA_x/2 ;  y1 := -PA_y/2 ;
   x2 :=  PA_x/2 ;  y2 :=  PA_y/2 ;
   GL_LINE(C,x1,y1,x2,y2);

   // ΍W_
   i := ClipPoint(WR_Ox,WR_Oy,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 0) then begin
      ax1 := Round( ( WR_Ox - WD_x1 ) * MM_dot );
      ay1 := Round(-( WR_Oy - WD_y2 ) * MM_dot );
      with C do begin
         Pen.Color := clOlive ;
         MoveTo(ax1-5,ay1);   LineTo(ax1+6,ay1);
         MoveTo(ax1,ay1-5);   LineTo(ax1,ay1+6);
      end;
   end;

   // ΍W_
   i := ClipPoint(0.0,0.0,WD_x1,WD_y1,WD_x2,WD_y2);
   if (i = 0) then begin
      ax1 := Round( ( 0.0 - WD_x1 ) * MM_dot );
      ay1 := Round(-( 0.0 - WD_y2 ) * MM_dot );
      with C do begin
         Pen.Color := clRed ;
         MoveTo(ax1-5,ay1);   LineTo(ax1+6,ay1);
         MoveTo(ax1,ay1-5);   LineTo(ax1,ay1+6);
      end;
   end;
end;

// Svf}
procedure GL_ALLDAT(C:TCanvas) ;
var
   i,j,jj : integer ;
   wx1,wy1,wx2,wy2,wr1,wa1,wa2 : Double ;
   k,k1,k2,kc,kl,kwi : integer ;
   kw : double ;
   ptns : array of Double ;   // }p^[(ړxZ)
   ptnn : integer ;           // p^[
   ptn1 : integer ;           // p^[}݈ʒu(ptnnNo.)
   ptn2 : double ;            // p^[}݈ʒu(mm)
begin
   with C do begin
      Pen.Mode  := pmCopy ;
      Pen.Color := clBlack ;
      Brush.Style := bsClear ;
      for k:=0 to LayTblN-1 do begin
         if (LayTbl[k].cnt = 0) then continue;  // vf=0͎̎̃C
         if not(LayTbl[k].dsp)  then continue;  // Display ͎̃C
         for i:=0 to Dat_N-1 do begin
            if (LayTbl[k].no = Dat[i].lay) then begin
               k1 := LayTbl[k].dc ; // CF
               k2 := LayTbl[k].dl ; // C
               kw := LayTbl[k].wid; // C
               // C
               if (Dat[i].col <> -1) then k1 := Dat[i].col ;   // CFł͂Ȃ
               if (Dat[i].lin <> -1) then k2 := Dat[i].lin ;   // Cł͂Ȃ
               if (Dat[i].wid >=0.0) then kw := Dat[i].wid ;   // Cł͂Ȃ
               // F
               kc := 0 ;
               if (k1 >= 0) then begin
                  if (k1 <= ColTblN) then kc := ColTbl[k1].val;
               end
               else begin
                  k1 := Abs(k1) - 2 ;
                  if (k1 >= 0)and(k1 <= 256*256*256-1) then kc := k1;
               end;

               ptnn := 0 ;
               ptns := nil ;
               if (SC_mode) then begin // ڍו\[h
                  // 
                  for j:=0 to LinTblN-1 do begin
                     if (LinTbl[j].no = k2) then begin
                        ptnn := LinTbl[j].n ;
                        SetLength(ptns,ptnn);
                        for jj:=0 to ptnn-1 do begin
                           ptns[jj] := LinTbl[j].ptn[jj] * LayTbl[k].lsc ;
                        end;
                        break;
                     end;
                  end;
                  // 
                  if (kw*MM_dot > 200.0) then begin
                     kwi := 200;
                  end
                  else if (kw*MM_dot <= 0.0) then
                     kwi := 0
                  else
                     kwi := Round(kw*MM_dot);
                  //
                  Pen.Color := kc ;
                  Pen.Style := psSolid ;
                  Pen.Width := kwi ;
               end
               else begin  // ȈՕ\[h
                  // 
                  kl := 0 ;
                  for j:=0 to LinTblN-1 do begin
                     if (LinTbl[j].no = k2) then begin
                        kl := LinTbl[j].val;
                        break;
                     end;
                  end;
                  //
                  Pen.Color := kc ;
                  Pen.Style := psSolid ;
                  Pen.Width := 0 ;
                  Case(kl)of
                  1: Pen.Style := psDash;
                  2: Pen.Style := psDot;
                  3: Pen.Style := psDashDot;
                  4: Pen.Style := psDashDotDot;
                  end;
               end;

               Case(Dat[i].typ) of
               1: begin
                     wx1 := Dat[i].p1 *LayTbl[k].sc;
                     wy1 := Dat[i].p2 *LayTbl[k].sc;
                     wx2 := Dat[i].p3 *LayTbl[k].sc;
                     wy2 := Dat[i].p4 *LayTbl[k].sc;
                     if (SC_mode) then begin // ڍו\[h
                        ptn1 := 0 ;
                        ptn2 := 0.0 ;
                        GL_LINE2(C,wx1,wy1,wx2,wy2,ptnn,ptns,ptn1,ptn2);
                     end
                     else begin  // ȈՕ\[h
                        GL_LINE(C,wx1,wy1,wx2,wy2);
                     end;
                  end;
               2: begin
                     wx1 := Dat[i].p1 *LayTbl[k].sc;
                     wy1 := Dat[i].p2 *LayTbl[k].sc;
                     wr1 := Dat[i].p3 *LayTbl[k].sc;
                     if (SC_mode) then begin // ڍו\[h
                        ptn1 := 0 ;
                        ptn2 := 0.0 ;
                        GL_CIRCLE2(C,wx1,wy1,wr1,ptnn,ptns,ptn1,ptn2);
                     end
                     else begin  // ȈՕ\[h
                        GL_CIRCLE(C,wx1,wy1,wr1);
                     end;
                  end;
               3: begin
                     wx1 := Dat[i].p1 *LayTbl[k].sc;
                     wy1 := Dat[i].p2 *LayTbl[k].sc;
                     wr1 := Dat[i].p3 *LayTbl[k].sc;
                     wa1 := Dat[i].p4;
                     wa2 := Dat[i].p5;
                     if (SC_mode) then begin // ڍו\[h
                        ptn1 := 0 ;
                        ptn2 := 0.0 ;
                        GL_ARC2(C,wx1,wy1,wr1,wa1,wa2,ptnn,ptns,ptn1,ptn2);
                     end
                     else begin  // ȈՕ\[h
                        GL_ARC(C,wx1,wy1,wr1,wa1,wa2);
                     end;
                  end;
               4: begin
                     Pen.Style := psSolid ;
                     Pen.Width := 0 ;
                     wx1 := Dat[i].p1 *LayTbl[k].sc;
                     wy1 := Dat[i].p2 *LayTbl[k].sc;
                     GL_POINT(C,wx1,wy1);
                  end;
               5: begin
                     Font.Color := Dat[i].col ;
                     wx1 := Dat[i].p1 *LayTbl[k].sc;
                     wy1 := Dat[i].p2 *LayTbl[k].sc;
                     wr1 := Dat[i].p3 *LayTbl[k].sc;
                     wa1 := Dat[i].p4 *LayTbl[k].sc;
                     wa2 := Dat[i].p5 *LayTbl[k].sc;
                     GL_TEXT(C,wx1,wy1,wr1,wa1,wa2,Dat[i].p6,Dat[i].lin,Dat[i].font,Dat[i].moji) ;
                  end;
               end;

               ptns := nil ;  // ꎞIEp^[
            end;
         end;
      end;
   end;
end;

end.
 